<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, inject } from 'vue';
import Button from '@/components/general/Button.vue';
import ChatBubble from '@/components/general/ChatBubble.vue';
import { isRelativeUrl } from '@/lib/utils';
import { useRouter } from 'vue-router';
import { useChatStore } from '@/stores/chat';
import { storeToRefs } from 'pinia';
import MarkdownRenderer from '@/components/general/MarkdownRenderer.vue';

const configuration = inject<any>('configuration');
const router = useRouter();
const store = useChatStore();
const { activeChatUuid, tab } = storeToRefs(store);

const props = defineProps<{
    name: string,
    message: string,
    person: string,
    avatar?: string,
    image?: boolean,
    uuid: string
}>();

const getImagePath = computed(() => {
    return configuration.apiServer + props.message;
});

const isURLPath = computed(() => {
    return isRelativeUrl(props.message);
});

const getAvatarPath = computed(() => {
    return configuration.apiServer + props.avatar;
});

const handleOpenChat = () => {
    activeChatUuid.value = props.uuid;
    if (props.person)
        tab.value = "person";
    else if (isURLPath.value)
        tab.value = "image";
    else
        tab.value = "chat";
    router.push({ path: '/overview/chat/' + props.uuid });
};

</script>
<template>
    <div
        class="min-w-80 min-h-80 max-w-80 max-h-80 bg-white shadow-md mb-4 relative select-none rounded-lg p-4 flex flex-col gap-2 justify-between">
        <h3 class="text-lg line-clamp-1 text-ellipsis h-6 text-center min-h-6">{{ name }}</h3>
        <div class="flex flex-row w-full gap-2">
            <Tooltip :tooltip="person" v-if="person">
                <div class="size-8 min-w-8 min-h-8 max-h-8 max-w-8">
                    <div class="rounded-full w-full h-full bg-gray-200 text-gray-500 text-center flex flex-col justify-center"
                        v-if="!avatar"><i class="ri-user-line"></i></div>
                    <img class="rounded-full object-contain h-full w-full" :src="getAvatarPath" v-else />
                </div>
            </Tooltip>
            <ChatBubble position="left" color="#e2e8f0">
                <div class="max-h-52 max-w-[calc(100dvw-49%)]">
                    <img class="object-contain h-full max-h-40" :src="getImagePath" v-if="image && isURLPath" />
                    <div class="line-clamp-[6] text-ellipsis hyphens-auto text-justify max-h-40" lang="de" v-else>
                        <MarkdownRenderer :source="message" />
                    </div>

                </div>
            </ChatBubble>
        </div>
        <div><Button variant="accent1" size="small" @click="handleOpenChat"><i class="ri-chat-1-line mr-1"></i>{{
                $t('ai.chat.continue.label') }}</Button></div>
    </div>
</template>
